Ticket #37230

NVDA 日本語版 2017.3jp の説明

Open Date: 2017-05-30 18:41 Last Update: 2017-08-25 09:40

Reporter: nishimoto Owner: (None)
Type: 報告 Status: Closed
Component: (None) MileStone: (None)
Priority: 5 - Medium Severity: 5 - Medium
Resolution: Fixed

Details

これは「NVDA日本語版の説明」に相当する内容をまとめるためのチケットです。

例えば 2017.2jp の変更点は下記のようにまとめています。

http://www.nvda.jp/nvda2017.2jp/ja/readmejp.html#toc65

変更点のまとめは 2017.1jp までは OSDN にリンクしていましたが、 2017.2jp からは GitHub issues へのリンクにしました。

2017.3jp からは、 NVDA日本語版のソースコードに関わる作業の記録はまず GitHub issues で行い、 必要に応じて OSDN のチケットで告知したりまとめを作ったりする、 という運用にしたいと思います。

2017.3jp に紐付いた GitHub issues は下記のマイルストーンに割り当てられます。

https://github.com/nvdajp/nvdajp/milestone/5

https://github.com/nvdajp/nvdajpmiscdep/milestone/5

本家の翻訳チームも GitHub への移行が予定されており、 NVDA 本家版が依存する外部パッケージの開発もほとんど GitHub に活動の場が移りました。 今後は NVDA 日本語チームの皆様に GitHub に慣れていただく必要があります。

そこで OSDN と GitHub で重複する機能を、NVDA 日本語チームにおいても、 すこしずつ GitHub に移していきたいと思います。 ご理解いただければ幸いです。

Attachment File List

No attachments

Ticket History (3/27 Histories)

2017-05-30 18:41 Updated by: nishimoto
  • New Ticket "NVDA 日本語版 2017.3jp の説明" created
2017-05-31 13:07 Updated by: nishimoto
Comment

ようこそ画面のレイアウト調整

https://github.com/nvdajp/nvdajp/issues/25

2017-06-13 15:23 Updated by: nishimoto
Comment

予定している作業のメモ

デフォルト音声を JTalk tohoku-f01 に変更する

https://github.com/nvdajp/nvdajp/issues/26

日本語設定「点字メッセージの表示終了」オプションの廃止

https://github.com/nvdajp/nvdajp/issues/28

本家 2017.3 で点字メッセージ表示をタイムアウトしないオプションが導入され、 いま日本語設定で独自に追加している 「点字メッセージの表示終了待ち時間の設定を有効化」 をチェックなしにすることと同じことができます。

2017-06-17 19:49 Updated by: nishimoto
Comment

検討中の作業

Escape を NVDA 制御キーにするオプション

https://github.com/nvdajp/nvdajp/pull/29

Apple の MacBook シリーズには Insert キーがないため Mac の仮想環境で日本語の Windows を動かして NVDA を使いたい人は NVDA 制御キーを Caps にも Insert にも割り当てることができません。

このことはアクセシビリティチェックのために NVDA を使いたい日本の技術者には、 大きな問題であったと認識しています。

また Apple の日本語キーボードには「無変換」や「変換」のかわりに「英数」「かな」キーがありますが、 ゲスト環境に適切に認識させるためには複雑な設定が必要で、必要なツールも入手できなくなりつつあります。

最近の Sierra で修飾キー Escape (Esc) が Caps に割り当て可能になったことを踏まえ、 Escape キーを NVDA キーとして使用するオプションがあればいいように思えてきました。

NVDA は内部的に Escape キーを特殊な目的にほとんど使っておらず、 技術的には非常に容易です。 もちろん Escape はフォーカスモードから抜ける操作に必要であり、 そもそも Windows の操作でも多くの場面で必要になるのですが、 Escape を素早く2回押せば Escape として認識させることができるので、 多くの場合にはこれで用が足りるのではないかと考えています。

Windows が英語キーボードのドライバで動いていれば Caps が使用可能なので、 今後は日本語キーボードの Caps がちゃんと NVDA キーとして使えるようになることも、 主に Microsoft に問題提起していく課題の一つと思います。

2017-06-24 10:52 Updated by: nishimoto
Comment

ランドマークの点字表記

本家 2017.3 からランドマークの表記は略語で点字出力されるが、 日本語版ではいままでの仕様に合わせて以下のようにする:

NABCCモードの場合:本家版の略語を使う(ユーザーガイドで説明)

NABCCモードでない場合:ランドマークの用語を日本語化して点字表示する

https://github.com/nvdajp/nvdajp/pull/31

2017-06-26 18:50 Updated by: nishimoto
Comment

次の日本語ベータ版で日本語設定「点字メッセージ表示終了待ち時間」を廃止する予定です。

本家版 2017.3 の点字設定「メッセージの表示を終了させない」オプションが実装されています。

設定ファイルの自動変換は行わないので、 お手数ですが「待ち時間」チェックなしに相当する動作をさせたい場合は、 新しい「メッセージの表示を終了させない」オプションをチェックにしてください。

2017-07-09 17:06 Updated by: nishimoto
Comment

デフォルト音声を JTalk tohoku-f01 に変更する

https://github.com/nvdajp/nvdajp/issues/26

2017.3jp-beta-170709 から反映されています。 また、いままで f01 は他の音声に比べてスピードが遅かったので、 この音声だけ特別に速くしました。

2017-07-20 12:47 Updated by: nishimoto
Comment

KGS点字ディスプレイドライバで英語2級点字の文字入力ができなさそうに見える問題

https://github.com/nvdajp/nvdajp/issues/39

2017-07-20 21:56 Updated by: nishimoto
Comment

KGS点字ディスプレイドライバで、コマンドが割り当てられていない点字パターンの入力をエラーにしない修正:

https://github.com/nvdajp/nvdajp/pull/40

他のドライバーでやられている処理に合わせました。

2017-08-01 16:10 Updated by: nishimoto
Comment

私の環境では NVDA 日本語版の点字ビューアーが点字フォントを表示できなくなりました。 どうやら "DejaVu Sans" フォントの点字パターンがなにか変わっているようです。 Windows 10 に LibreOffice 5.3.4.2 をインストールした影響かも知れませんが、はっきりとはわかりません。

NVDA 日本語版の説明

https://www.nvda.jp/nvda2017.2jp/ja/readmejp.html#toc48

Windows XP で点字ビューアーを使うためには点字フォントが必要です。OpenOffice.org や LibreOffice をインストールすると点字フォントもインストールされます。

と説明しているのですが、Windows XP 対応をあきらめて Windows システムフォントを優先したほうがよいかも知れません。

2017-08-01 16:25 Updated by: nishimoto
Comment

DejaVu Sans フォントの指定をやめる変更:

https://github.com/nvdajp/nvdajp/pull/41

2017-08-01 17:59 Updated by: nishimoto
Comment

確認したこと

  • NVDA で DejaVu Sans フォントの指定をやめると、Windows XP と Vista では点字ビューアーの点字が出ない。7 と 8.1 と 10 では点字パターンが表示される。
  • LibreOffice 5.3.4.2 をインストールすると、XP, Vista, 7, 8.1 の環境では DejaVu Sans フォントが使用できる。
  • Windows 10 (1703) では LibreOffice 5.3.4.2 をインストールしても DejaVu Sans フォントが(例えばメモ帳から)選択可能にならない。似た名前のフォントはいくつか追加されるが、点字表示できるのは DejaVu Math TeX Gyre だけである

以上のことから、対策案

  • 10 だけ DejaVu Sans フォントを使わないようにする(つまり 7 以降では LibreOffice インストール不要と明記する)
  • XP と Vista だけ DejaVu Sans フォントを選ぶようにする(つまり Vista 以前のみ LibreOffice インストールを推奨する)

どちらかというと前者=過去のバージョンに関するワークアラウンドを選ぶほうが安全に思える。

2017-08-01 19:48 Updated by: nishimoto
Comment

先ほどのコメントの訂正

「XP と Vista だけ DejaVu Sans フォントを選ぶようにする」

過去のバージョンに関するワークアラウンドのつもりで書いたのはこちらでした。

マージして動作を確認したので、日本語版の説明を変更します。

diff --git a/user_docs/ja/readmejp.t2t b/user_docs/ja/readmejp.t2t
index 36b1f4c..22094ee 100644
--- a/user_docs/ja/readmejp.t2t
+++ b/user_docs/ja/readmejp.t2t
@@ -9,7 +9,7 @@
 + はじめに +


-- 最終更新日:2017年6月26日
+- 最終更新日:2017年8月1日
 - 更新者:NVDA日本語チーム (nvdajp@nvda.jp 西本卓也)


@@ -624,7 +624,7 @@ NVDA 日本語版はツール「スピーチビューアー」を Alt+Tab で切

 点字ビューアーは音声出力される情報を点字に変換しているので、点字ディスプレイへの実際の出力と内容が一致しないことがありま
す。

-Windows XP で点字ビューアーを使うためには点字フォントが必要です。OpenOffice.org や LibreOffice をインストールすると点字フォントもインストールされます。
+Windows XP または Vista で点字ビューアーを使うためには DejaVu Sans フォントが必要です。LibreOffice をインストールすると DejaVu Sans フォントもインストールされます。
2017-08-02 12:08 Updated by: nishimoto
Comment

きょう本家 master にマージされた Windows 10 UWP 文字認識 (OCR) について。

動作することは確認できたが、もともとこのエンジンが日本語を「1文字=1単語」として処理しており、 NVDA 側に「単語と単語はスペースで区切る」という処理が入っているため、 日本語を認識すると、文字が必ずスペースで区切られた結果になっている。

本家で他の言語のユーザーから何かリアクションがあるかどうか様子を見ながら、 日本語版で何か対策するかどうか、もう少し考えます。

参考:ユニバーサルWindowsアプリ開発で OCR を使う記事。 OcrWordオブジェクトに日本語の場合は文字単位でテキストが入ることが書かれている。

http://www.atmarkit.co.jp/ait/articles/1410/09/news119.html

2017-08-03 10:27 Updated by: nishimoto
Comment

入力する場所を間違えたので再度。

KGS点字ドライバと英語2級点字の入力

https://github.com/nvdajp/nvdajp/issues/39

について、2017.3jp での方針と現状の実装のコメント

  • 現在の KGS ドライバーはそのままとする
  • brailleMemo experimental という新しいドライバーを追加。対応機種は KGS と同じ
  • 点字ディスプレイからの文字入力について、本家 2017.3 でのドライバーに合わせて「左親指 = 7の点」および「右親指 = 8の点」とする
  • デフォルトでは「左親指はバックスペース」「右親指はエンター」「左右の親指の同時押しは2級点字の変換実行」になるが、入力ジェスチャーで変更可能
  • BM46 でスペースを入力できるように「4の点+8の点」を特別に「スペース」として NVDA に解釈させる処理を追加(これは入力ジェスチャーで変更できない)

この実装で確認できたこと

  • 入力テーブル「Unicode 点字」にすると、ユニコード点字パターンを1から6の点までについて入力可能
  • 入力テーブル「統一英語点字1級」「アメリカ英語2級点字」などで、1級点字の文字入力、b で but などの2級点字入力、数符を使う数字入力などが可能

現在の課題

  • 入力テーブル「統一英語点字2級」を選ぶと何を入力しても RuntimeError になる(調査中)
2017-08-03 10:54 Updated by: nishimoto
Comment

さらに追記

AppVeyor ビルドで確認したら、統一英語点字2級での入力も正常に動作しました。

https://ci.appveyor.com/project/TakuyaNishimoto/nvdajp/build/jpbeta-359/artifacts

2017-08-03 12:34 Updated by: nishimoto
Comment

Windows 10 OCR を日本語で使いやすくする改善

https://github.com/nvdajp/nvdajp/issues/44

作業ブランチとプルリクエスト

https://github.com/nvdajp/nvdajp/pull/45

前の単語の最後の文字と次の単語の最初の文字がいずれも unicode east asian narrow の場合にのみ「単語」間に空白を挟んで結果を返す、 という実装で、だいたい期待される動作になりました。

本家も string freeze になったので、これでほぼ NVDA 2017.3jp の開発は完了となる見込みです。

2017-08-04 08:23 Updated by: nishimoto
Comment

string freeze 直前に点字の略語が追加された。 いままでの仕様に合わせて NABCC モードでは略語を使い、 非 NABCC モードでは日本語に変換する。

https://github.com/nvdajp/nvdajp/issues/46

ただし、今回、点字パターンで以下を表記するようになったので、 これについては NABCC モードに関わらず本家と同じ出力としたい。

「区切り線」 「押されています」 「押されていません」 「チェック」 「一部チェック」 「チェックなし」

2017-08-04 17:28 Updated by: nishimoto
Comment

実験版ブレイルメモドライバの親指操作が左手モードと右手モードで異なることに関連して、

http://www.nvda.jp/nvda2017.2jp/ja/readmejp.html#toc44

NVDA 日本語版の説明で Enter とスペースは右手モード左手モードのどちらも共通のように書かれていた。

間違っていたのなら修正しなければならない。

2017-08-12 21:30 Updated by: nishimoto
Comment

点字パターンをそのまま出力できない問題の修正

https://github.com/nvdajp/nvdajpmiscdep/issues/45

2017-08-13 11:28 Updated by: nishimoto
Comment

直っていないケースがあったので再修正。

https://github.com/nvdajp/nvdajpmiscdep/issues/45

点字パターンを読みに変換するために辞書を使うのをやめて、 形態素解析は点字パターンをそのまま出力し、 後処理で読みに変換するように変更した。

また、連続する記号や空白が形態素解析で未知語としてひとまとめにされたときに、 末尾が空白になっている単語にさらにマスアケを行わないように修正した。

2017-08-14 14:12 Updated by: nishimoto
Comment

「っていう」の点訳

https://github.com/nvdajp/nvdajpmiscdep/issues/46

連語なので辞書エントリをカスタマイズして分かち書きに対応。

2017-08-14 16:19 Updated by: nishimoto
Comment

BrailleMemo experimental の仕様変更

https://github.com/nvdajp/nvdajp/issues/49

-- 点字ディスプレイドライバ「BrailleMemo experimental」を追加しました。本家 2017.3 でのドライバーに合わせて「左親指 = 7の点」および「右親指 = 8の点」としています。また「4の点+8の点」を特別に「スペース」として NVDA に解釈させる処理を追加しています。
+- 点字ディスプレイドライバ「BrailleMemo experimental」を追加しました。本家 2017.3 でのドライバーに合わせて、従来 Ctrl に割り当てていた左手小指を「7の点」に、従来 Shift (select) に割り当てていた右手小指を「8の点」に割り当てています。文字の 入力は点字設定の「入力テーブル」に基づいて行われます。
2017-08-15 11:06 Updated by: nishimoto
Comment

BM32 だと 左小指キー1:「read システムキーボードの左ウインドウズを押す機能をエ ミュレート」 になるとのこと。

現在の説明だと BM46 に依存した記述になってしまっているらしい。

Read と Ctrl をどちらも dot7 に割り当てるようにすれば BM32 と BM46 に同時に対応できるか?

2017-08-15 19:59 Updated by: nishimoto
Comment

BrailleMemo experimental の仕様をもとに戻します。

diff --git a/user_docs/ja/readmejp.t2t b/user_docs/ja/readmejp.t2t
index 76893f3..1928dcf 100644
--- a/user_docs/ja/readmejp.t2t
+++ b/user_docs/ja/readmejp.t2t
@@ -9,7 +9,7 @@
 + はじめに +


-- 最終更新日:2017年8月14日
+- 最終更新日:2017年8月15日
 - 更新者:NVDA日本語チーム (nvdajp@nvda.jp 西本卓也)


@@ -815,7 +815,14 @@ NVDA 日本語チームは[以下の変更および改良 https://osdn.net/ticke
 - 日本語設定「点字メッセージの表示終了待ち時間の設定を有効化」を廃止しました。点字設定「メッセージの表示を終了させない」オプションが 2017.3 から利用できるので、こちらをお使いください。
 - 「EscapeをNVDA制御キーとして使用」オプションを「ようこそ画面」および「日本語設定」に追加しました。このオプションをチェックしている場合も Escape キーをすばやく2回繰り返して押せば Escape は元のキーの機能として入力できます。
 - 本家版 2017.3 で点字ディスプレイ出力用に追加されたロールやランドマークなどの略語は、従来の NVDA 日本語版と同様に、「コンピューター点字(NABCC)を使用」がチェックされている場合のみ使われてます。NABCCを使用しない場合は、ユーザーガイドで略語 が使われるとされている箇所で、日本語に翻訳されたロールやランドマークの名前が使われます。
-- 英語の2級点字の文字入力に対応する実験用の点字ディスプレイドライバ「BrailleMemo experimental」を追加しました。対応機種は従来の「KGS BrailleMemoシリーズ」と同じです。従来 Ctrl に割り当てていた左手小指を「7の点」に、従来 Shift (select) に割り当てていた右手小指を「8の点」に割り当てています。
+- 英語の2級点字の文字入力に対応する実験用の点字ディスプレイドライバ「BrailleMemo experimental」を追加しました。
+  - 対応機種は従来の「KGS BrailleMemoシリーズ」と同じです。
+  - 左手親指は「7の点」(直前の1マス分の点字または1文字を消去)です。
+  - 右手親指は「8の点」(点字入力の変換と Enter の入力)です。
+  - 左右の親指を同時に(7と8の点を)押すと点字入力の変換を行います。
+  - 右手人差し指と右手親指を同時に(4と8の点を)押すとスペースを入力できます。
+  - 点字ディスプレイドライバで直接アルファベットなどの文字入力を処理していた従来の機能は一部無効化されています。
+  - BM46 以外の機種では十分に検証が行われていません。
 - 点字ディスプレイのドライバ「KGS BrailleMemo シリーズ」および「KGS BrailleNote 46C/46D」において、機能が割り当てられていない点字パターンの入力がエラーにならないように修正しました。
 - 「点字ビューアー」を Windows 7 以降の環境で使うときにはシステムの標準フォントが使われるように変更しました。以前は「DejaVu Sans フォント」をインストールする必要がありました。なお、Windows XP および Vista では引き続き「DejaVu Sans フォント」が必要です。このフォントは LibreOffice をインストールすることで利用可能です。
 - 「Windows 10 文字認識」で日本語を文字認識したときに、文字と文字の間に不要な空白が入らないようにしました。本家版 2017.3 では日本語の漢字やカナは1文字ずつ空
2017-08-25 09:01 Updated by: None
2017-08-25 09:40 Updated by: nishimoto
  • Milestone Update from 2017.3jp (closed) to (None)
  • Ticket Close date is changed to 2017-08-25 09:40
  • Status Update from Open to Closed
  • Resolution Update from None to Fixed

Edit

Please login to add comment to this ticket » Login